import os
from git import *
import git
from time import (time, altzone)
import datetime
from gitdb import IStream
import psycopg2
import pandas as pd

# my folder path
dirName = r'C:\Users\my\Desktop\All_PROJECTS\projects'
# Get the list of all files in directory tree at given path
listOfProjects = os.listdir(dirName)
# print(listOfProjects)
con = psycopg2.connect(database="merge_conflict", user="postgres", password="2019", host="127.0.0.1", port="5432")
print("successfully connected to nature_merge!")
cur = con.cursor()
f1= open("local_sha_data_summary.txt","w+")
f2= open("remote_sha_data_summary.txt","w+")
f3= open("resolution_sha_data_summary.txt","w+")
for project in listOfProjects:
#leftsha features
    query1 = "SELECT leftsha,id, basesha,rightsha,sha from merge_conflict_dataset where htmlurl like'%"+project+"'"
    cur.execute(query1)
    rows1 = cur.fetchall()
    rowarray1_list = []
#Extract data for Local version
    for row in rows1:
     try:
            path =Repo(r'C:\\Users\\my\\Desktop\\All_PROJECTS\\projects\\'+project)
            commit1 = path.commit(row[0])
            auth1 = commit1.author.name
            date1 = commit1.authored_datetime
            time1 = date1.time()
            dateonly1 = date1.date()

            No_commits1 = path.git.rev_list('--ancestry-path','--count', row[0]+'..'+ row[2])
            # numberofcommits_v1 = ('HEAD', '--count', '--author=' + auth1)
            numberofcommits_owner_local = path.git.rev_list('HEAD', '--author=' + auth1, '--count', '--before=' + (str(date1)))
            sql11 = "UPDATE merge_conflict_dataset set  date_time_for_the_local=%s and number_commits_local=%s  number_commits_owner_local=%s where id=%s"
            cur.execute(sql11, (date1,No_commits1,numberofcommits_owner_local,row[1]))


            con.commit()
            f1.write(project +"\t"+str(row[1])+ "\t successfully added data\n")
     except Exception as e:
            f1.write(str(e)+"\n")
            f1.write(str(row[1])+"\t error adding data\n")
            pass
    f1.close()
#Extract data for Remote Version

    try:
            path = Repo(r'C:\\Users\\my\\Desktop\\All_PROJECTS\\projects\\' + project)
            commit2 = path.commit(row[3])
            auth2 = commit2.author.name
            date2 = commit2.authored_datetime
            time2 = date2.time()
            dateonly2 = date2.date()
            No_commits2 = path.git.rev_list('--ancestry-path', '--count', row[0] + '..' + row[2])
            numberofcommitsv2 = path.git.rev_list('HEAD', '--count', '--author=' + auth2)
            numberofcommits_owner_remote = path.git.rev_list('HEAD', '--author=' + auth2, '--count','--before=' + (str(date2)))

            sql22 = "UPDATE merge_conflict_dataset set  date_time_for_the_remote=%s and number_commits_remote=%s  number_commits_owner_remote=%s where id=%s"
            cur.execute(sql22, (date2,No_commits2,numberofcommits_owner_remote,row[1]))
            # sql2 = "UPDATE  projects_features_609 set rightshav2_commit_date=%s and number_commits_rightshav2=%s where id=%s"
            # cur.execute(sql2, (dateonly2,No_commits2, row[1]))
            con.commit()
            f2.write(project + "\t" + str(row[1]) + "\t successfully added data \n")
         except Exception as e:
            f2.write(str(e)+"\n")
            f2.write(str(row[1]) + "\t error adding data\n")
         pass
    f2.close()



    # for row in rows2:
    try:
            path = Repo(r'C:\\Users\\my\\Desktop\\All_PROJECTS\\projects\\' + project)
            commit3 = path.commit(row[4])
            auth3 = commit2.author.name
            date3 = commit3.authored_datetime
            time3 = date3.time()
            dateonly3 = date3.date()
            dayofweek = dateonly3.weekday()
            # number_commits_owner_resolver = path.git.rev_list('HEAD', '--count', '--author=' + auth3)
            number_commits_owner_resolver = path.git.rev_list('HEAD', '--author=' + auth3, '--count','--before=' + (str(date3)))
            sql33 = "UPDATE merge_conflict_dataset set  date_time_for_the_resloution=%s and number_commits_owner_resolver=%s where id=%s"
            cur.execute(sql33, (auth3,time3,dateonly3,dayofweek,number_commits_owner_resolver, row[1]))
            # sql3 = "UPDATE  projects_features_609 set time=%s and conflicting_resolution_day=%s where id=%s"
            # cur.execute(sql3, (time3,dayofweek, row[1]))
            con.commit()
            f3.write(project + "\t" + str(row[1]) + "\t successfully added data\n")
    except Exception as e:
            f3.write(str(e)+"\n")
            f3.write(str(row[1]) + "\t error adding data\n")
    pass
    f3.close()
