import csv

import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import os

import psycopg2
from sklearn.metrics import precision_score, recall_score, f1_score, confusion_matrix, make_scorer, accuracy_score, \
    classification_report
from sklearn.naive_bayes import MultinomialNB, GaussianNB
from sklearn.svm import SVC
from sklearn.neighbors import KNeighborsClassifier
from sklearn.tree import DecisionTreeClassifier
from sklearn.ensemble import RandomForestClassifier, AdaBoostClassifier
from sklearn.model_selection import GridSearchCV, cross_val_predict, cross_validate
from xgboost import XGBClassifier
from sklearn.feature_extraction.text import CountVectorizer
from sklearn.feature_extraction.text import TfidfTransformer
from sklearn.model_selection import KFold
from sklearn.model_selection import cross_val_score
from sklearn.pipeline import Pipeline
from numpy import mean
from numpy import std
import numpy as np
from sklearn import metrics, model_selection
from sklearn.preprocessing import LabelEncoder
from sklearn.model_selection import KFold
from sklearn.tree import DecisionTreeClassifier
import random
from sklearn.model_selection import KFold
import numpy as np
import numpy

all_dfs = []

df= pd.read_csv(r'C:\Users\my\Downloads\merge_conflict_dataset.csv') # read files# read files
df =df.fillna(df.mode().iloc[0])


labelencoder_X = LabelEncoder()

df['filetype'] = labelencoder_X.fit_transform(df['filetype'])  # names


X = df.drop(['resolution_time','number_commits_owner_resolver','id','date_time_for_the_resolution','date_time_for_the_local','date_time_for_the_remote', 'numberofconfilctingfile','number_commits_local','number_commits_remote','number_commits_owner_resolver','number_commits_owner_local'], axis=1).to_numpy()
all_projects=[]

Y= df['developerdecision'].to_numpy()
projects_ids=(df['project_id'].unique())
number_projects=(len(projects_ids))


# random.shuffle(projects_ids)

# Training with the data of 90% of projects, and testing with the data of the remaining 10% of projects.

truth=[]
final_pred=[]
project_index=[]
for index in range(len(projects_ids)):
    project_index.append(index)

X_index=np.array(project_index)
KF = KFold(n_splits=10)


for train_index, test_index in KF.split(X_index):
    X_index_train, X_index_test = X_index[train_index], X_index[test_index]
    # Y_index_train, Y_index_test = Y[train_index], Y[test_index]

    project_test = []
    project_train = []
    all_projects=[]



    for item in X_index_train:
        project_train.append(projects_ids[item])
    for item in X_index_test:
        project_test.append(projects_ids[item])


    all_training_project = numpy.array(project_train)
    all_testing_project= numpy.array(project_test)
    # model1 = RandomForestClassifier()

    X_train = []
    Y_train = []
    X_test = []
    Y_test = []
    total_test = []
    total_pred = []

    for p in range (len(X)):
        if X[p][2] in all_training_project:
            # print(all_training_project)
            # print(X[p][3])
            Y_train.append((X[p][3]))

            # print(X[p])

            X_train.append((X[p]))
    # print(len(X_train))






    for pp in range (len(X)):
        if X[pp][2] in all_testing_project:
            # print(X[pp][3])
            Y_test.append(X[pp][3])

            # print(X[pp])

            X_test.append(X[pp])
    # print(len(Y_test))



    X_train1=np.array(X_train)
    Y_train1=np.array(Y_train)
    X_test1=np.array(X_test)
    Y_test1=np.array(Y_test)

    X_train11=np.delete(X_train1, [2, 3], 1)
    X_test11 = np.delete(X_test1, [2, 3], 1)

    # print(len(X_train11))
    # print(len(Y_test1))





    model1 = RandomForestClassifier(n_estimators=150)
    # model1=AdaBoostClassifier()
    # model1=DecisionTreeClassifier()
    # model1=GaussianNB()
    predictor = model1.fit(X_train11, Y_train1)
    pred = predictor.predict(X_test11)
    Y_test1 = Y_test1.tolist()
    pred = pred.tolist()
    total_test = total_test + Y_test1
    total_pred = total_pred + pred
    # # print(project_id)

    # print(len(total_pred))
    # print(len(X_train11))
    # print(len(total_test))
    # # print(len(X_test))
    # # print(accuracy_score(total_test, total_pred))

    for tru in total_test:
        truth.append(tru)

    for pr in total_pred:
        final_pred.append(pr)
# calculate overall folders
print(confusion_matrix(truth,final_pred))
    # #
print(classification_report(truth,final_pred))










